//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Call_Help         //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_manonfire","_grouponfire","_fireman","_troublepos","_checkgroup",
			"_leader","_countradio","_tempgroups","_groupside","_uArray","_DAC_Temp_Groups",
			"_ct","_kw","_distgroup","_distunits","_cg","_sg","_fnr","_gnr","_rw",
			"_skillgroup","_delay","_hgroup","_hleader","_enddelay","_run","_go","_TempAll"
		];

			_manonfire = _this select 0;_grouponfire = _this select 1;_fireman = _this select 2;_troublepos = getpos _manonfire;
			_run = true;_leader = leader _grouponfire;_countradio = DAC_Radio_Max;_TempAll = DAC_All_Groups;_DAC_Temp_Groups = [];
			_tempgroups = [];_groupside = side _manonfire;_go = true;_checkgroup = _grouponfire;_uArray = [];

if(({alive _x} count units _grouponfire) == 0) exitwith {};

_uArray = _uArray + [format["%1",side _leader]];
switch (format["%1",side _leader]) do
{
	case "WEST":	{if(DAC_Res_Side == 1) then {_uArray = _uArray + ["GUER"]}};
	case "EAST":	{if(DAC_Res_Side == 0) then {_uArray = _uArray + ["GUER"]}};
	case "GUER":	{
						if(DAC_Res_Side == 1) then {_uArray = _uArray + ["WEST"]};
						if(DAC_Res_Side == 0) then {_uArray = _uArray + ["EAST"]};
					};
	default {};
};

DAC_Call_Groups = DAC_Call_Groups + [_grouponfire];
[_manonfire,4] spawn DAC_fAISpeak;

while{_run} do
{
	while{_go} do
	{
		_ct = 0;_kw = 100000;
		while{_ct < count _TempAll} do
		{
			_distgroup = _TempAll select _ct;
			if(_distgroup in _tempgroups) then
			{
				_ct = _ct + 1;
			}
			else
			{
				_distunits = ((units _distgroup select 0) distance (units _grouponfire select 0));
				if(_distunits < _kw) then {_kw = _distunits;_checkgroup = _distgroup};
				_ct = _ct + 1;
			};
		};
		if(_kw == 100000) then
		{
			_run = false;
			_go = false
		}
		else
		{
			_tempgroups = _tempgroups + [_checkgroup];
			if((count _tempgroups) == (count _TempAll)) then
			{
				_tempgroups = _tempgroups + [_grouponfire];
				_run = false;
				_go = false
			};
		};
	};
};
sleep 0.1;
_run = true;_go = true;

while{_run} do
{
	_cg = 0;_sg = 0;
	{if(alive _x) then {_cg = _cg + 1;_sg = _sg + skill _x}} foreach units _grouponfire;
	if(_cg == 0) then
	{
		_run = false;
	}
	else
	{
		_skillgroup = _sg / _cg;
		_fnr = 0;_gnr = 0;_rw = DAC_Radio_Dist * _skillgroup;_delay = DAC_Radio_Time / _skillgroup;
		if((getpos _manonfire select 2) < 5) then
		{
			[1,0,_grouponfire,0,_fireman distance leader _grouponfire] spawn DAC_fShowRadio;
		};
		while{_go} do
		{
			sleep (_delay + random _delay);
			if((_gnr >= count _tempgroups)
			|| ((({format["%1",side leader _x] in _uArray} count _DAC_Temp_Groups) >= DAC_Radio_Count) && (_fnr == 1))
			|| (({alive _x} count units _grouponfire) == 0)
			|| (!(_grouponfire in DAC_Hit_Groups))) then
			{
				_run = false;
				_go = false;
			}
			else
			{
				_hgroup = _tempgroups select _gnr;_hleader = leader _hgroup;
				if((!(canmove vehicle _hleader))
				|| (!(format["%1",side _hleader] in _uArray))
				|| (({alive _x} count units _hgroup) < (DAC_Intern select 2))
				|| (_hgroup == _grouponfire)) then
				{
					_gnr = _gnr + 1;
				}
				else
				{
					sleep ((_hleader distance _troublepos) / 200);
					if((_hgroup in DAC_Help_Groups) || (_hgroup in DAC_Fire_Groups)
					|| (_hgroup in DAC_Hit_Groups) || (_hgroup in DAC_Cover_Groups) || (_hgroup in _DAC_Temp_Groups)
					|| (_hgroup in DAC_No_Support) || ((_hleader distance _troublepos) > _rw)
					|| (({alive _x} count units _hgroup) == 0))	then
					{
						_gnr = _gnr + 1;
					}
					else
					{
						if(alive _manonfire) then {_troublepos = getpos _manonfire};
						[_hgroup] spawn DAC_fWaitForHelp;_DAC_Temp_Groups = _DAC_Temp_Groups + [_hgroup];
						[(units _hgroup select 0),7] spawn DAC_fAISpeak;
						_gnr = _gnr + 1;
						_fnr = 1;
					};
				};
			};
		};
		_run = false;
	};
};