//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Config_Units      //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_TypNumber","_TempArray",
			"_Unit_Pool_S","_Unit_Pool_V","_Unit_Pool_T","_Unit_Pool_A"
		];

			_TypNumber = _this select 0;_TempArray = [];

switch (_TypNumber) do
{
//----------------------------------Brit Woodland Test---------------------------------------------------------------
	case 0:
	{
		_Unit_Pool_S = 	[
				"VBS2_GB_Army_AFVCrew_W_L22A2_None_CrewHelmet_None",
				"VBS2_GB_ARMY_HeliPilot_W_L9",
				"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_Radio",
				"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_None"
						];
		_Unit_Pool_V = 	["VBS2_GB_Army_Jackal_MWMIK_W_GMG","VBS2_GB_Army_Jackal_MWMIK_W_HMG",
				"VBS2_GB_Army_Pinzgauer_4x4_W","VBS2_GB_Army_Pinzgauer_6x6_W",
				"VBS2_GB_Army_LandRover_WMIK_W_GMG","VBS2_GB_Army_LandRover_WMIK_W_HMG",
				"VBS2_GB_Army_LandRover_WMIK_W_GPMG","VBS2_GB_Army_LandRover_Wolf_110_W_HardTop_Bowman",
				"VBS2_GB_Army_LandRover_Wolf_110_W_SoftTop_Bowman","VBS2_GB_Army_LandRover_Wolf_110_FFR_W"];
		_Unit_Pool_T = 	["VBS2_GB_FV107_W","VBS2_GB_FV107_W_EPBA_TS09","VBS2_GB_Challenger2_W_Chobham",
				"VBS2_GB_Challenger2_W_DorchesterL2","VBS2_GB_Challenger2_W_DorchesterL2A",
				"VBS2_GB_Army_FV432_W_L37","VBS2_GB_Army_FV432_Bulldog_W_L2","VBS2_GB_Army_FV432_Bulldog_W_L37",
				"VBS2_GB_FV510_W","VBS2_GB_FV510_W_Chobham","VBS2_GB_FV510_W_WRAP2","VBS2_GB_FV511_W",
				"VBS2_GB_FV511_W_Chobham","VBS2_GB_FV511_W_WRAP2","VBS2_GB_FV514_W","VBS2_GB_FV514_W_Chobham",
				"VBS2_GB_FV514_W_WRAP2"];
		_Unit_Pool_A = 	["VBS2_GB_WAH64D_LONGBOW","VBS2_GB_ARMY_Lynx_AH7_GPMG","VBS2_GB_ARMY_Lynx_AH7_TOW"];
	};
//-------------------------------------Militia all------------------------------------------------------------
	case 1:
	{
		_Unit_Pool_S = 	[
				"vbs2_iq_militia_01_akm","vbs2_iq_militia_01_aks74u","vbs2_iq_militia_02_akm",
				"vbs2_iq_militia_03_akm","vbs2_iq_militia_01_rpg","vbs2_iq_militia_01_makarov",
				"vbs2_iq_militia_02_rpg","vbs2_iq_militia_01_pkm","vbs2_iq_militia_02_aks74u",
				"vbs2_iq_militia_02_makarov","vbs2_iq_militia_02_pkm","vbs2_iq_militia_03_rpg",
				"vbs2_iq_militia_03_aks74u","vbs2_iq_militia_03_makarov","vbs2_iq_militia_03_pkm",
				"vbs2_iq_militia_04_akm","vbs2_iq_militia_04_rpg","vbs2_iq_militia_04_aks74u",
				"vbs2_iq_militia_04_makarov","vbs2_iq_militia_04_pkm","vbs2_iq_militia_05_akm",
				"vbs2_iq_militia_05_rpg","vbs2_iq_militia_05_aks74u","vbs2_iq_militia_05_makarov",
				"vbs2_iq_militia_05_pkm","vbs2_iq_militia_06_akm","vbs2_iq_militia_06_rpg",
				"vbs2_iq_militia_06_aks74u","vbs2_iq_militia_06_makarov","vbs2_iq_militia_06_pkm",
				"vbs2_iq_militiaelder_01_akm","vbs2_iq_militiaelder_01_rpg","vbs2_iq_militiaelder_01_aks74u",
				"vbs2_iq_militiaelder_01_makarov","vbs2_iq_militiaelder_01_pkm","vbs2_iq_militiaelder_02_akm",
				"vbs2_iq_militiaelder_02_rpg","vbs2_iq_militiaelder_02_aks74u","vbs2_iq_militiaelder_02_makarov",
				"vbs2_iq_militiaelder_02_pkm"
						];
		_Unit_Pool_V = 	["VBS2_IQ_Militia_datsuntruck_pickup_02_dshkm","VBS2_IQ_Militia_datsuntruck_pickup_dshkm",
				"VBS2_IQ_Militia_datsuntruck_pickup_02_pkm","VBS2_IQ_Militia_datsuntruck_pickup_pkm",
				"VBS2_IQ__Militia_datsuntruck_pickup_02_spg9","VBS2_IQ__Militia_datsuntruck_pickup_spg9",
				"VBS2_IQ_Militia_datsuntruck_pickup_02","VBS2_IQ_Militia_datsuntruck_pickup_01"];
		_Unit_Pool_T =	[];
		_Unit_Pool_A = 	[];
	};
//-------------------------------------Insurgents all------------------------------------------------------------
	case 2:
	{
		_Unit_Pool_S = 	[
				"vbs2_iq_insurg_01_aks74u","vbs2_iq_insurg_02_aks74u","vbs2_iq_insurgLeader_01_akm",
				"vbs2_iq_insurg_01_akm","vbs2_iq_insurg_01_rpg","vbs2_iq_insurg_03_ak74gla",
				"vbs2_iq_insurg_02_rpgmodern","vbs2_iq_insurg_02_pkm","vbs2_iq_insurg_02_strela",
				"vbs2_iq_insurgLeader_01_ak74n","vbs2_iq_insurgLeader_01_aks74PSO","vbs2_iq_insurgLeader_01_aks74uSD",
				"vbs2_iq_insurg_01_svd","vbs2_iq_insurg_01_ak74","vbs2_iq_insurg_01_ak74gla","vbs2_iq_insurg_01_rpgmodern",
				"vbs2_iq_insurg_01_strela","vbs2_iq_insurg_01_pkm","vbs2_iq_insurg_01_rpk74","vbs2_iq_insurgLeader_02_ak74n",
				"vbs2_iq_insurgLeader_02_akm","vbs2_iq_insurgLeader_02_aks74PSO","vbs2_iq_insurgLeader_02_aks74uSD",
				"vbs2_iq_insurg_02_ak74","vbs2_iq_insurg_02_ak74gla","vbs2_iq_insurg_02_akm","vbs2_iq_insurg_02_rpg",
				"vbs2_iq_insurg_02_rpk74","vbs2_iq_insurg_02_svd","vbs2_iq_insurgLeader_03_ak74n","vbs2_iq_insurgLeader_03_akm",
				"vbs2_iq_insurgLeader_03_aks74PSO","vbs2_iq_insurgLeader_03_aks74uSD","vbs2_iq_insurg_03_ak74",
				"vbs2_iq_insurg_03_akm","vbs2_iq_insurg_03_rpg","vbs2_iq_insurg_03_rpgmodern","vbs2_iq_insurg_03_strela",
				"vbs2_iq_insurg_03_aks74u","vbs2_iq_insurg_03_pkm","vbs2_iq_insurg_03_rpk74","vbs2_iq_insurg_03_svd",
				"vbs2_iq_insurgLeader_04_ak74n","vbs2_iq_insurgLeader_04_akm","vbs2_iq_insurgLeader_04_aks74PSO",
				"vbs2_iq_insurgLeader_04_aks74uSD","vbs2_iq_insurg_04_ak74","vbs2_iq_insurg_04_ak74gla",
				"vbs2_iq_insurg_04_akm","vbs2_iq_insurg_04_rpg","vbs2_iq_insurg_04_rpgmodern",
				"vbs2_iq_insurg_04_strela","vbs2_iq_insurg_04_aks74u","vbs2_iq_insurg_04_pkm","vbs2_iq_insurg_04_rpk74",
				"vbs2_iq_insurg_04_svd","vbs2_iq_insurgLeader_05_ak74n","vbs2_iq_insurgLeader_05_akm",
				"vbs2_iq_insurgLeader_05_aks74PSO","vbs2_iq_insurgLeader_05_aks74uSD","vbs2_iq_insurg_05_ak74",
				"vbs2_iq_insurg_05_ak74gla","vbs2_iq_insurg_05_akm","vbs2_iq_insurg_05_rpg","vbs2_iq_insurg_05_rpgmodern",
				"vbs2_iq_insurg_05_strela","vbs2_iq_insurg_05_aks74u","vbs2_iq_insurg_05_pkm","vbs2_iq_insurg_05_rpk74",
				"vbs2_iq_insurg_05_svd","vbs2_iq_insurg_05_rpk74","vbs2_iq_insurg_05_pkm","vbs2_iq_insurg_05_aks74u",
				"vbs2_iq_insurg_04_aks74u","vbs2_iq_insurg_04_akm","vbs2_iq_insurg_04_ak74","vbs2_iq_insurg_03_aks74u"
						];
		_Unit_Pool_V = 	["VBS2_IQ_Insurg_datsuntruck_pickup_02_dshkm","VBS2_IQ_Insurg_datsuntruck_pickup_dshkm",
				"VBS2_IQ_Insurg_datsuntruck_pickup_02_pkm","VBS2_IQ_Insurg_datsuntruck_pickup_pkm",
				"VBS2_IQ_Insurg_datsuntruck_pickup_02_spg9","VBS2_IQ_Insurg_datsuntruck_pickup_spg9",
				"VBS2_IQ_Insurg_datsuntruck_pickup_02","VBS2_IQ_Insurg_datsuntruck_pickup_01"];
		_Unit_Pool_T = 	[];
		_Unit_Pool_A = 	[];
	};
//-------------------------------------Civi mix------------------------------------------------------------
	case 3:
	{
		_Unit_Pool_S = 	[
				"vbs2_iq_civ_man_01","vbs2_iq_civ_man_02","vbs2_iq_civ_man_03","vbs2_iq_civ_man_04",
				"vbs2_iq_civ_man_05","vbs2_iq_civ_man_06","vbs2_iq_civ_woman_1","vbs2_iq_civ_woman_2",
				"vbs2_iq_child_01","vbs2_iq_child_02","vbs2_iq_child_03","vbs2_iq_child_04",
				"vbs2_iq_civ_dockworker_03","vbs2_iq_civ_dockworker_04","vbs2_iq_civ_dockworker_01",
				"vbs2_iq_civ_dockworker_02","vbs2_iq_civ_manelder_01","vbs2_iq_civ_manelder_02",
				"vbs2_iq_civ_manelder_01_angry","vbs2_iq_civ_manelder_02_angry","vbs2_iq_civ_man_01_angry",
				"vbs2_iq_civ_man_02_angry","vbs2_iq_civ_man_03_angry","vbs2_iq_civ_man_04_angry",
				"vbs2_iq_civ_man_05_angry","vbs2_iq_civ_man_06_angry"
				];
		_Unit_Pool_V = 	["VBS2_ZZ_Farm_Tractor","VBS2_IQ_Insurg_datsuntruck_pickup_01","VBS2_IQ_Insurg_datsuntruck_pickup_02"];
		_Unit_Pool_T = 	["VBS2_ZZ_Farm_Tractor"];
		_Unit_Pool_A = 	[];
	};
//-------------------------------------------------------------------------------------------------
	Default {
				if(DAC_Basic_Value != 5) then
				{
					DAC_Basic_Value = 5;publicvariable "DAC_Basic_Value";
					hintc "Error: DAC_Config_Units > No valid config number";
				};
				if(true) exitwith {};
			};
};

if(count _this == 2) then
{
	_TempArray = _TempArray + [_Unit_Pool_S,_Unit_Pool_V,_Unit_Pool_T,_Unit_Pool_A];
}
else
{
	_TempArray = _Unit_Pool_V + _Unit_Pool_T + _Unit_Pool_A;
};
_TempArray