//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Sector_Check.sqf  //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_run","_zone","_zid","_msize","_size1","_size2","_pos2","_yStep","_modeE","_modeF",
			"_sect","_yVal","_ref","_incr","_decr","_mPos","_mSets","_i","_z","_c","_r","_m","_a",
			"_za","_list","_marker1","_marker2","_WVal","_EVal","_sVal","_E","_F","_sideF","_sideE","_hTime"
		];
		
			_run = 1;_i = 0;_r = 0;_c = 0;_zone = _this select 0;_zid = _this select 1;_msize = [];_size1 = 0;_size2 = 0;
			_yStep = DAC_SectSet select 0;_modeE = ((DAC_SectSet select 4) select 0);_modeF = ((DAC_SectSet select 5) select 0);
			_list = [];_WVal = 0;_EVal = 0;_sect = 0;_za = objNull;_ref = DAC_SectSet select 1;_incr = DAC_SectSet select 2;_z = objNull;
			_a = [];_decr = DAC_SectSet select 3;_m = "";_marker1 = "";_marker2 = "";_E = [];_F = [];_yVal = 0;_hTime = time;
			_sideE = DAC_SectSet select 6;_sideF = DAC_SectSet select 7;

waituntil{DAC_Basic_Value == 1};

if((isServer) && (({((isPlayer _x) && (local _x))} count DAC_Players) == 0)) then
{
	if(time > 0) exitwith {};
}
else
{
	if((typeName _zone) == "ARRAY") then
	{
		_z = ((_this select 0 ) select 0);
		_zone = ((_this select 0 ) select 0);
		_size1 = ((_this select 0 ) select 1);
		_size2 = ((_this select 0 ) select 2);
	}
	else
	{
		while {_c < count DAC_Zones} do
		{
			_a = DAC_Zones select _c;
			if((call compile (_a select 0)) == _zone) then
			{
				_size1 = _a select 1;_size2 = _a select 2;
				_c = ((count DAC_Zones) + 1);_z = (call compile (_a select 0));
			}
			else
			{
				_c = _c + 1;
			};
		};
	};

	if(isNull _z) then
	{
		hintc "Error > DAC_Sector_Check : zone not found.";
	}
	else
	{
		sleep (random 1);
		_mPos  = position _zone;
		if(_ref <= 0) then {_ref = 0.01};
		_pos2  =[(_mPos select 0),(_mPos select 1) - (_size2)];_yVal = (_size2 / _yStep);
		_mSets =[
					[(_size1 - 3),3,((_mPos select 1) - _size2),(_mPos select 0)],
					[3,(_size2 + 3),(_mPos select 1),((_mPos select 0) + _size1)],
					[(_size1 - 3),3,((_mPos select 1) + _size2),(_mPos select 0)],
					[3,(_size2 + 3),(_mPos select 1),((_mPos select 0) - _size1)]
				];

		while {_i < count _mSets} do
		{
			_r = random 100;_m = format["_zu%1%2%3",_zid,_i,_r];
			_za = createmarker [_m, [((_mSets select _i) select 3),((_mSets select _i) select 2)]];_za setMarkerShape "RECTANGLE";
			_za setMarkerSize [((_mSets select _i) select 0),((_mSets select _i) select 1)];_za setMarkerColor "ColorBlack";_i = _i + 1;
		};

		while {_run > 0} do
		{
			switch (_run) do
			{
				case 1:	{
							_m = format["_n_%1_%2",_zid,time];_marker2 = createMarker [_m, _mPos];
							_marker2 setMarkerShape "RECTANGLE";_marker2 setMarkerSize [_size1, _size2];
							_marker2 setMarkerColor "ColorWhite";
							_m = format["_m_%1_%2",_zid,time];_marker1 = createMarker [_m, _pos2];
							_marker1 setMarkerShape "RECTANGLE";_marker1 setMarkerSize [_size1, 0.1];
							_marker1 setMarkerColor "ColorBlack";_run = 2;
						};
				case 2:	{
							//SectorLoop
							_list = List _zone;
							_E = [];_F = [];
							sleep _ref;
							{if((alive _x) && (format["%1",side _x] in _sideF)) then {_F = _F + crew _x}} foreach _list;
							{if((alive _x) && (format["%1",side _x] in _sideE)) then {_E = _E + crew _x}} foreach _list;
							_WVal = ((count _F) * _incr);_EVal = ((count _E) * _incr);
							if(_WVal > 0) then {if(_EVal == 0) then {_run = 4} else {if(_EVal < _WVal) then {_run = 6} else {_run = 7}}} else {if(_EVal == 0) then {_run = 3} else {_run = 5}};
						};
				case 3:	{
							//Refresh
							if((DAC_Sectors select _zid) > 0) then
							{
								if(((DAC_Sectors select _zid) == 2) || ((DAC_Sectors select _zid) == 4)) then
								{
									if(_modeE == 0) then
									{
										if(_sect > 0) then
										{
											_sect = _sect - _decr;
											_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
											_marker1 setMarkerSize [_size1, (_sect * _yVal)];
										}
										else
										{
											if((DAC_Sectors select _zid) != 0) then {DAC_Sectors set [_zid, 0]};
										};
									}
									else
									{
										if(time > _htime) then
										{
											if(_sect > 0) then
											{
												_sect = _sect - _decr;
												_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
												_marker1 setMarkerSize [_size1, (_sect * _yVal)];
											}
											else
											{
												if((DAC_Sectors select _zid) != 0) then {DAC_Sectors set [_zid, 0]};
											};
										};
									};
								}
								else
								{
									if(_modeF == 0) then
									{
										if(_sect > 0) then
										{
											_sect = _sect - _decr;
											_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
											_marker1 setMarkerSize [_size1, (_sect * _yVal)];
										}
										else
										{
											if((DAC_Sectors select _zid) != 0) then {DAC_Sectors set [_zid, 0]};
										};
									}
									else
									{
										if(time > _htime) then
										{
											if(_sect > 0) then
											{
												_sect = _sect - _decr;
												_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
												_marker1 setMarkerSize [_size1, (_sect * _yVal)];
											}
											else
											{
												if((DAC_Sectors select _zid) != 0) then {DAC_Sectors set [_zid, 0]};
											};
										};
									};
								};
							};
							_run = 2;
						};
				case 4:	{
							//Set10
							if(((DAC_Sectors select _zid) == 2) || ((DAC_Sectors select _zid) == 4)) then
							{
								DAC_Sectors set [_zid, 1];_sect = 0;_marker1 setMarkerSize [_size1, 0.1];_marker1 setMarkerPos _pos2;_hTime = (time + _modeF);_run = 2;
							}
							else
							{
								if(_sect >= _yStep) then
								{
									DAC_Sectors set [_zid, 3];_marker1 setMarkerSize [_size1,_size2];
									_marker1 setMarkerPos _mPos;
									if(((DAC_SectSet select 5) select 1) > 0) then
									{
										_run = 0;
									}
									else
									{
										_hTime = (time + _modeF);_run = 2;
									};
								}
								else
								{
									DAC_Sectors set [_zid, 1];_marker1 setMarkerColor "ColorGreen";
									_sVal = _WVal;_sect = _sect + _sVal;_hTime = (time + _modeF);
									_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
									_marker1 setMarkerSize [_size1, (_sect * _yVal)];_run = 2;
								};
							};
						};
				case 5:	{
							//Set01
							if(((DAC_Sectors select _zid) == 1) || ((DAC_Sectors select _zid) == 3)) then
							{
								DAC_Sectors set [_zid, 2];_sect = 0;_marker1 setMarkerSize [_size1, 0.1];_marker1 setMarkerPos _pos2;_hTime = (time + _modeE);_run = 2;
							}
							else
							{
								if(_sect >= _yStep) then
								{
									DAC_Sectors set [_zid, 4];_marker1 setMarkerSize [_size1,_size2];
									_marker1 setMarkerPos _mPos;
									if(((DAC_SectSet select 4) select 1) > 0) then
									{
										_run = 0;
									}
									else
									{
										_hTime = (time + _modeE);_run = 2;
									};
								}
								else
								{
									DAC_Sectors set [_zid, 2];_marker1 setMarkerColor "ColorRed";
									_sVal = _EVal;_sect = _sect + _sVal;_hTime = (time + _modeE);
									_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
									_marker1 setMarkerSize [_size1, (_sect * _yVal)];_run = 2;
								};
							};
						};
				case 6:	{
							//Set21
							if(((DAC_Sectors select _zid) == 2) || ((DAC_Sectors select _zid) == 4)) then
							{
								DAC_Sectors set [_zid, 1];_sect = 0;_marker1 setMarkerSize [_size1, 0.1];_marker1 setMarkerPos _pos2;_hTime = (time + _modeF);_run = 2;
							}
							else
							{
								if(_sect >= _yStep) then
								{
									DAC_Sectors set [_zid, 3];_marker1 setMarkerSize [_size1,_size2];
									_marker1 setMarkerPos _mPos;
									if(((DAC_SectSet select 5) select 1) > 0) then
									{
										_run = 0;
									}
									else
									{
										_hTime = (time + _modeF);_run = 2;
									};
								}
								else
								{
									DAC_Sectors set [_zid, 1];_marker1 setMarkerColor "ColorGreen";
									_sVal = _WVal;_sect = _sect + _sVal;_hTime = (time + _modeF);
									_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
									_marker1 setMarkerSize [_size1, (_sect * _yVal)];_run = 2;
								};
							};
						};
				case 7:	{
							//Set12
							if(((DAC_Sectors select _zid) == 1) || ((DAC_Sectors select _zid) == 3)) then
							{
								DAC_Sectors set [_zid, 2];_sect = 0;_marker1 setMarkerSize [_size1, 0.1];_marker1 setMarkerPos _pos2;_hTime = (time + _modeE);_run = 2;
							}
							else
							{
								if(_sect >= _yStep) then
								{
									DAC_Sectors set [_zid, 4];_marker1 setMarkerSize [_size1,_size2];
									_marker1 setMarkerPos _mPos;
									if(((DAC_SectSet select 4) select 1) > 0) then
									{
										_run = 0;
									}
									else
									{
										_hTime = (time + _modeE);_run = 2;
									};
								}
								else
								{
									DAC_Sectors set [_zid, 2];_marker1 setMarkerColor "ColorRed";
									_sVal = _EVal;_sect = _sect + _sVal;_hTime = (time + _modeE);
									_marker1 setMarkerPos [(_pos2 select 0),(_pos2 select 1) + (_sect * _yVal)];
									_marker1 setMarkerSize [_size1, (_sect * _yVal)];_run = 2;
								};
							};
						};
				Default{};
			};
		};
	};
};