//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Config_Units      //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_TypNumber","_TempArray",
			"_Unit_Pool_S","_Unit_Pool_V","_Unit_Pool_T","_Unit_Pool_A"
		];

			_TypNumber = _this select 0;_TempArray = [];

switch (_TypNumber) do
{
//-------------------------------------------------------------------------------------------------
	case 0:
	{
		_Unit_Pool_S = 	[
							"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_Radio",
							"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_Radio",
							"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_Radio",
							"VBS2_GB_Army_Soldier_W_L85A2_BeltOrder_Helmet_Radio"
						];
		_Unit_Pool_V = 	[];
		_Unit_Pool_T = 	[];
		_Unit_Pool_A = 	[];
	};
//-------------------------------------------------------------------------------------------------
	case 1:
	{
		_Unit_Pool_S = 	[
							"SoldierWCrew","SoldierWPilot","SquadLeaderW","Soldierwb",
							"Soldierwg","Soldierwmg","Soldierwar","Soldierwmg","Soldierwat",
							"Soldierwmedic","Soldierwat","Soldierwsniper","SoldierWSaboteur","SquadLeaderW",
							"Soldierwat","Soldierwmedic","Soldierwminer","SoldierWSaboteurPipe",
							"SoldierWSaboteurPipe2","SoldierWSaboteurRecon","SoldierWSaboteurAssault"
						];
		_Unit_Pool_V = 	[	"HMMWV50","HMMWV","Truck5t","HMMWVMK","Truck5tOpen","Truck5tMG","HMMWVTOW","Truck5tMG","Stryker_TOW"];
		_Unit_Pool_T =	[	"M1Abrams","Vulcan","M113","Vulcan","M1Abrams","Stryker_ICV_M2"];
		_Unit_Pool_A = 	[	"AH1W","UH60MG","MH6"];
	};
//-------------------------------------------------------------------------------------------------
	case 2:
	{
		_Unit_Pool_S = 	[
							"SoldierGCrew","SoldierGPilot","SquadLeaderG","SoldierGb",
							"SoldierGat","SoldierGg","SoldierGat","SoldierGmg","SoldierGaa",
							"SoldierGmedic","SoldierGat","SoldierGaa","SoldierGsniper",
							"SoldierGb","SoldierGmedic","SoldierGminer","SoldierGmg"
						];
		_Unit_Pool_V = 	[	"LandroverMG"];
		_Unit_Pool_T = 	[	"M113_RACS"];
		_Unit_Pool_A = 	[	"UH60MGRACS","MH6_RACS","AH6_RACS"];
	};
//-------------------------------------------------------------------------------------------------
	case 3:
	{
		_Unit_Pool_S = 	[
							"Civilian","Civilian2","Civilian3","Civilian4","Civilian5",
							"Civilian6","Civilian7","Civilian8","Civilian9","Civilian10"
						];
		_Unit_Pool_V = 	[	"datsun1_civil_2_covered","hilux1_civil_1_open","UralCivil","SkodaBlue","Bus_city","car_sedan","SkodaRed"];
		_Unit_Pool_T = 	[	"Tractor"];
		_Unit_Pool_A = 	[];
	};
//-------------------------------------------------------------------------------------------------
	Default {
				if(DAC_Basic_Value != 5) then
				{
					DAC_Basic_Value = 5;publicvariable "DAC_Basic_Value";
					hintc "Error: DAC_Config_Units > No valid config number";
				};
				if(true) exitwith {};
			};
};

if(count _this == 2) then
{
	_TempArray = _TempArray + [_Unit_Pool_S,_Unit_Pool_V,_Unit_Pool_T,_Unit_Pool_A];
}
else
{
	_TempArray = _Unit_Pool_V + _Unit_Pool_T + _Unit_Pool_A;
};
_TempArray