//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Dyn_Weather       //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_weatherdist","_weatherunit","_weathermaxcas","_weathermaxfog","_oldweather",
			"_oldfog","_run","_timefact","_waittime","_code","_go"
		];
		
			_weatherdist = _this select 0;_weatherunit = _this select 1;_weathermaxcas = _this select 2;
			_weathermaxfog = _this select 3;DAC_Weather = overcast;DAC_Fog = fog;DAC_Rain = rain;
			_oldweather = DAC_Weather;_oldfog = DAC_Fog;_run = 1;_timefact = 0;_waittime = 0;
			_code = _this select 4;DAC_WTime = 0;_go = 1;

if((_weatherdist == 0) || (_weatherunit == 0)) then {_run = 0};
if(_code == 3) then {_run = 6};

	
while {_run > 0} do
{
	switch (_run) do
	{
		case 1:	{
					waituntil {(DAC_Basic_Value > 0)};
					if(!(isServer)) then
					{
						_run = 5;
					}
					else
					{
						sleep _weatherdist;
						_run = 2;
					};
				};
		case 2:	{
					DAC_Weather = random _weathermaxcas;DAC_Fog = random _weathermaxfog;DAC_Rain = random 1;
					_timefact = (if((DAC_Weather - _oldweather) > 0) then
								{
									_weatherunit * ((DAC_Weather - _oldweather));
								}
								else
								{
									_weatherunit * ((_oldweather - DAC_Weather));
								});
					_oldweather = DAC_Weather;_oldfog = DAC_Fog;
					publicvariable "DAC_Weather";publicvariable "DAC_Fog";publicvariable "DAC_Rain";_run = 3;
				};
		case 3:	{
					_waittime = time + _timefact;
					_timefact setovercast DAC_Weather;
					_timefact setrain DAC_Rain;
					_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if((DAC_Weather < 0) && (isServer)) then
						{
							DAC_Weather = _oldweather;DAC_Fog = _oldfog;DAC_WTime = (_timefact - time);
							publicvariable "DAC_Weather";publicvariable "DAC_Fog";publicvariable "DAC_WTime";
						};
						if(time > _waittime) then {_go = 0};
					};
					if(!(isServer)) then {_run = 5} else {_run = 4};
				};
		case 4:	{
					_timefact setfog DAC_Fog;
					sleep 1;
					_waittime = time + _timefact;_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(DAC_Weather < 0) then
						{
							DAC_Weather = _oldweather;DAC_Fog = _oldfog;DAC_WTime = (_timefact - time);
							publicvariable "DAC_Weather";publicvariable "DAC_Fog";publicvariable "DAC_WTime";
						};
						if(time > _waittime) then {_go = 0};
					};
					_run = 2;
				};
		case 5:	{
					_timefact setfog DAC_Fog;
					sleep 1;
					waituntil {((_oldweather != DAC_Weather) && (!(DAC_Weather < 0)))};
					_timefact = (if((DAC_Weather - _oldweather) > 0) then
								{
									_weatherunit * ((DAC_Weather - _oldweather));
								}
								else
								{
									_weatherunit * ((_oldweather - DAC_Weather));
								});
					_oldweather = DAC_Weather;_run = 3;
				};
		case 6:	{
					sleep 1;
					DAC_Weather = -1;publicvariable "DAC_Weather";
					waituntil {(DAC_Weather >= 0)};
					sleep 0.2;
					_oldweather = DAC_Weather;_oldfog = DAC_Fog;_timefact = DAC_WTime;
					_waittime = time + _timefact;
					_timefact setovercast DAC_Weather;
					_go = 1;
					while {_go > 0} do
					{
						sleep (1 + (random 1));
						if(time > _waittime) then {_go = 0};
					};
					sleep 1;
					_run = 5;
				};
		Default{};
	};
};