//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Init_Creator      //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private ["_start","_pa","_pn","_a","_sum","_end"];

	_start = time;DAC_SpawnDummy = "logic" createvehicle [0,0,0];
	//The next line is from Sickboy ;-)
	DAC_Trigger = createTrigger ["EmptyDetector",getArray(configFile >> "CfgWorlds" >> worldName >> "centerPosition")];
	DAC_Trigger setTriggerActivation ["Any", "PRESENT", true];
	DAC_Trigger setTriggerArea [25000, 25000, 0, true ];
	DAC_Trigger setTriggerStatements ["this", "", ""];

// DAC Arrays & Vars;

	DAC_Zone_Values = 640;DAC_InSpawn = false;DAC_All_Groups = [];DAC_Camp_Zones = [];
	DAC_AI_Behaviour = [];DAC_Spawn_CampsE = [];DAC_Spawn_CampsW = [];DAC_Camps_InUse = [];
	DAC_Min_Groups = [];DAC_West_Units = [];DAC_East_Units = [];DAC_Camp_Pool = [];
	DAC_Init_Values = [0,0];DAC_Init_Zone = [];DAC_Arti_Player = [0];DAC_Player_Arti = "";
	DAC_Init_Group = [];DAC_Init_WP = [];DAC_Init_Unit = [1,0,0,0,0];DAC_Zones = [];
	DAC_WP_Pool_S = [];DAC_WP_Pool_V = [];DAC_WP_Pool_T = [];DAC_WP_Pool_A = [];
	DAC_WP_Pool_H = [];DAC_WP_Pool_C = [];DAC_WP_Pool_B = [];DAC_Unit_Pool_S = [];
	DAC_Unit_Pool_V = [];DAC_Unit_Pool_T = [];DAC_Unit_Pool_A = [];DAC_Unit_Pool_C = [];
	DAC_Unit_Pool_O = [];DAC_Unit_Pool_H = [];DAC_Unit_Pool_B = [];DAC_Unit_Pool_D = [];
	DAC_GroupPoolE  = [];DAC_GroupPoolW  = [];DAC_GroupPoolR  = [];DAC_GroupPoolC  = [];
	DAC_Buildg_InUse = [];DAC_Arti_West = [0];DAC_Arti_East = [0];DAC_Arti_Array = [];DAC_Debug = [];
	DAC_Master_Init = 0;DAC_WPCount_Init = 0;DAC_AI_Path = format["DAC\AI_%1\",DAC_AI_AddOn];
	DAC_CheckZones = [];DAC_VehicleInUse = [];DAC_VehicleForUse = [];DAC_Arti_Veh = [];DAC_Static = [];

{_x = _x + [DAC_StartDummy]} foreach [DAC_Init_Zone,DAC_Init_WP,DAC_Init_Group,DAC_East_Units,DAC_West_Units];
[]execVM format["%1DAC_AI_Init.sqf",DAC_AI_Path];
_pa = 0;_pn = DAC_StartDummy;DAC_Players = [];

{
	if(!(format["%1",call compile _x] == scalar)) then 
	{
		DAC_Players = DAC_Players + [call compile _x];
	};
}	foreach DAC_STRPlayers;

if((count DAC_Players) == 0) then
{
	hintc format["Attention . . .\n\nthe Array DAC_STRPlayers contains none, or invalid names of units.\n\nPerhaps, you have forgotten to name	your player.\n\nPlease, name all editor placed units on your side. Then add these names	to the Array DAC_STRPlayers.\n\nThe AI will not react properly."];
	DAC_Basic_Value = 3;publicvariable "DAC_Basic_Value";
}
else
{
	While {_pa < count DAC_Players} do 
	{
		_pn = group (DAC_Players select _pa);
		if((!(format["%1",DAC_Players select _pa] == scalar))) then
		{
			{if(!(_x in DAC_Players)) then {DAC_Players = DAC_Players + [_x]}} foreach units _pn;
		};
		_pa = _pa + 1;
	};
};

DAC_InCreate = false;

	if(DAC_AI_Level > 4) then
	{
		DAC_AI_Level = 4;
	}
	else
	{
		if(DAC_AI_Level < 1) then
		{
			DAC_AI_Level = 1;
		};
	};

[1]execVM "DAC\Scripts\DAC_Init_Waypoint.sqf";

sleep 0.1;

	if((DAC_Com_Values select 1) > 0) then
	{
		DAC_InitText = format["# DAC V2.0 is initialized ..."];hint DAC_InitText;
	};

DAC_StartDummy setpos [10,10,0];
sleep 3;

waituntil {(({_x == 0} count DAC_Init_Counter) == 5)};
sleep 1;
_end = time;_sum = _end - _start;

if((DAC_Com_Values select 1) > 0) then
{
	if((DAC_Com_Values select 1) == 1) then
	{
		hint format["DAC V2.0 init successfully.\nRequired time: %1",_sum];
	}
	else
	{
		if((DAC_Com_Values select 1) == 2) then
		{
			hint format[
							"%4\n-------------------------------------------\n%5 Waypoints created\n%1 Units in\n%2 Group(s) created.\nRequired time: %3"
							,(DAC_Init_Values select 1),(DAC_Init_Values select 0),	_sum,DAC_InitText,DAC_WPCount_Init
						];
		}
		else
		{
				hint "Wrong Value -> DAC_Com_Values";
		};
	};
};

DAC_West_Units = DAC_West_Units - [DAC_StartDummy];DAC_East_Units = DAC_East_Units - [DAC_StartDummy];
sleep 1;
DAC_StartDummy setdir 180;DAC_Basic_Value = 1;publicvariable "DAC_Basic_Value";
DAC_Players = DAC_Players + [DAC_StartDummy];
[]execVM "DAC\Scripts\DAC_Clean_Arrays.sqf";
sleep 5;
if((DAC_Com_Values select 1) > 0) then {hint "Good luck soldier !"};
true